Index: /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 3924)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 3925)
@@ -2581,6 +2581,6 @@
 
 	pjsua_call_setting_default(&call_opt);
-	call_opt.audio_cnt = app_config.aud_cnt;
-	call_opt.video_cnt = app_config.vid.vid_cnt;
+	call_opt.aud_cnt = app_config.aud_cnt;
+	call_opt.vid_cnt = app_config.vid.vid_cnt;
 
 	pjsua_call_answer2(call_id, &call_opt, app_config.auto_answer, NULL, NULL);
@@ -2591,5 +2591,5 @@
 
 #if PJSUA_HAS_VIDEO
-	if (call_info.rem_offerer && call_info.rem_video_cnt) {
+	if (call_info.rem_offerer && call_info.rem_vid_cnt) {
 	    snprintf(notif_st, sizeof(notif_st), 
 		     "To %s the video, type \"vid %s\" first, "
@@ -2608,6 +2608,6 @@
 		  "Press a to answer or h to reject call",
 		  acc_id,
-		  call_info.rem_audio_cnt,
-		  call_info.rem_video_cnt,
+		  call_info.rem_aud_cnt,
+		  call_info.rem_vid_cnt,
 		  notif_st,
 		  call_info.remote_info.ptr,
@@ -2898,5 +2898,5 @@
 #if PJSUA_HAS_VIDEO
     /* Check if remote has just tried to enable video */
-    if (call_info.rem_offerer && call_info.rem_video_cnt)
+    if (call_info.rem_offerer && call_info.rem_vid_cnt)
     {
 	int vid_idx;
@@ -4239,6 +4239,6 @@
 
     pjsua_call_setting_default(&call_opt);
-    call_opt.audio_cnt = app_config.aud_cnt;
-    call_opt.video_cnt = app_config.vid.vid_cnt;
+    call_opt.aud_cnt = app_config.aud_cnt;
+    call_opt.vid_cnt = app_config.vid.vid_cnt;
 
     /* If user specifies URI to call, then call the URI */
@@ -4281,6 +4281,6 @@
 	/* Update call setting */
 	pjsua_call_setting_default(&call_opt);
-	call_opt.audio_cnt = app_config.aud_cnt;
-	call_opt.video_cnt = app_config.vid.vid_cnt;
+	call_opt.aud_cnt = app_config.aud_cnt;
+	call_opt.vid_cnt = app_config.vid.vid_cnt;
 
 	switch (menuin[0]) {
Index: /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 3924)
+++ /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 3925)
@@ -590,5 +590,5 @@
      * Default: 1
      */
-    unsigned         audio_cnt;
+    unsigned         aud_cnt;
 
     /**
@@ -598,5 +598,5 @@
      * Default: 1 (if video feature is enabled, otherwise it is zero)
      */
-    unsigned         video_cnt;
+    unsigned         vid_cnt;
 
 } pjsua_call_setting;
@@ -3615,8 +3615,8 @@
 
     /** Number of audio streams offered by remote */
-    unsigned		rem_audio_cnt;
+    unsigned		rem_aud_cnt;
 
     /** Number of video streams offered by remote */
-    unsigned		rem_video_cnt;
+    unsigned		rem_vid_cnt;
 
     /** Internal */
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 3924)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_call.c	(revision 3925)
@@ -511,8 +511,8 @@
     pj_bzero(opt, sizeof(*opt));
     opt->flag = PJSUA_CALL_INCLUDE_DISABLED_MEDIA;
-    opt->audio_cnt = 1;
+    opt->aud_cnt = 1;
 
 #if defined(PJMEDIA_HAS_VIDEO) && (PJMEDIA_HAS_VIDEO != 0)
-    opt->video_cnt = 1;
+    opt->vid_cnt = 1;
     opt->req_keyframe_method = PJSUA_VID_REQ_KEYFRAME_SIP_INFO |
 			     PJSUA_VID_REQ_KEYFRAME_RTCP_PLI;
@@ -530,5 +530,5 @@
 
 #if !PJMEDIA_HAS_VIDEO
-    pj_assert(opt->video_cnt == 0);
+    pj_assert(opt->vid_cnt == 0);
 #endif
 
@@ -542,6 +542,6 @@
 
 	/* Reinit media channel when media count is changed */
-	if (opt->audio_cnt != old_opt.audio_cnt ||
-	    opt->video_cnt != old_opt.video_cnt)
+	if (opt->aud_cnt != old_opt.aud_cnt ||
+	    opt->vid_cnt != old_opt.vid_cnt)
 	{
 	    pjsip_role_e role = rem_sdp? PJSIP_ROLE_UAS : PJSIP_ROLE_UAC;
@@ -1599,6 +1599,6 @@
     info->rem_offerer   = call->rem_offerer;
     if (call->rem_offerer) {
-	info->rem_audio_cnt = call->rem_aud_cnt;
-	info->rem_video_cnt = call->rem_vid_cnt;
+	info->rem_aud_cnt = call->rem_aud_cnt;
+	info->rem_vid_cnt = call->rem_vid_cnt;
     }
 
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 3924)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 3925)
@@ -1735,32 +1735,32 @@
 
 	    /* Check if we need to add new audio */
-	    if (maudcnt < call->opt.audio_cnt && 
-		mtotaudcnt < call->opt.audio_cnt)
+	    if (maudcnt < call->opt.aud_cnt &&
+		mtotaudcnt < call->opt.aud_cnt)
 	    {
-		for (mi = 0; mi < call->opt.audio_cnt - mtotaudcnt; ++mi)
+		for (mi = 0; mi < call->opt.aud_cnt - mtotaudcnt; ++mi)
 		    maudidx[maudcnt++] = (pj_uint8_t)call->med_cnt++;
 		
-		mtotaudcnt = call->opt.audio_cnt;
-	    }
-	    maudcnt = call->opt.audio_cnt;
+		mtotaudcnt = call->opt.aud_cnt;
+	    }
+	    maudcnt = call->opt.aud_cnt;
 
 	    /* Check if we need to add new video */
-	    if (mvidcnt < call->opt.video_cnt && 
-		mtotvidcnt < call->opt.video_cnt)
+	    if (mvidcnt < call->opt.vid_cnt &&
+		mtotvidcnt < call->opt.vid_cnt)
 	    {
-		for (mi = 0; mi < call->opt.video_cnt - mtotvidcnt; ++mi)
+		for (mi = 0; mi < call->opt.vid_cnt - mtotvidcnt; ++mi)
 		    mvididx[mvidcnt++] = (pj_uint8_t)call->med_cnt++;
 
-		mtotvidcnt = call->opt.video_cnt;
-	    }
-	    mvidcnt = call->opt.video_cnt;
+		mtotvidcnt = call->opt.vid_cnt;
+	    }
+	    mvidcnt = call->opt.vid_cnt;
 
 	} else {
 
-	    maudcnt = mtotaudcnt = call->opt.audio_cnt;
+	    maudcnt = mtotaudcnt = call->opt.aud_cnt;
 	    for (mi=0; mi<maudcnt; ++mi) {
 		maudidx[mi] = (pj_uint8_t)mi;
 	    }
-	    mvidcnt = mtotvidcnt = call->opt.video_cnt;
+	    mvidcnt = mtotvidcnt = call->opt.vid_cnt;
 	    for (mi=0; mi<mvidcnt; ++mi) {
 		mvididx[mi] = (pj_uint8_t)(maudcnt + mi);
@@ -1815,5 +1815,5 @@
 	if (pj_memchr(maudidx, mi, mtotaudcnt * sizeof(maudidx[0]))) {
 	    media_type = PJMEDIA_TYPE_AUDIO;
-	    if (call->opt.audio_cnt &&
+	    if (call->opt.aud_cnt &&
 		pj_memchr(maudidx, mi, maudcnt * sizeof(maudidx[0])))
 	    {
@@ -1822,5 +1822,5 @@
 	} else if (pj_memchr(mvididx, mi, mtotvidcnt * sizeof(mvididx[0]))) {
 	    media_type = PJMEDIA_TYPE_VIDEO;
-	    if (call->opt.video_cnt &&
+	    if (call->opt.vid_cnt &&
 		pj_memchr(mvididx, mi, mvidcnt * sizeof(mvididx[0])))
 	    {
@@ -2597,10 +2597,10 @@
      * would pass the SDP negotiation.
      */
-    if (maudcnt > call->opt.audio_cnt || mvidcnt > call->opt.video_cnt)
+    if (maudcnt > call->opt.aud_cnt || mvidcnt > call->opt.vid_cnt)
     {
 	pjmedia_sdp_session *local_sdp2;
 
-	maudcnt = PJ_MIN(maudcnt, call->opt.audio_cnt);
-	mvidcnt = PJ_MIN(mvidcnt, call->opt.video_cnt);
+	maudcnt = PJ_MIN(maudcnt, call->opt.aud_cnt);
+	mvidcnt = PJ_MIN(mvidcnt, call->opt.vid_cnt);
 	local_sdp2 = pjmedia_sdp_session_clone(tmp_pool, local_sdp);
 
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c	(revision 3924)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_vid.c	(revision 3925)
@@ -1631,5 +1631,5 @@
 	goto on_error;
 
-    call->opt.video_cnt++;
+    call->opt.vid_cnt++;
 
     return PJ_SUCCESS;
@@ -1701,5 +1701,5 @@
 	    unsigned i, vid_cnt = 0;
 
-	    /* Check if video_cnt in call option needs to be increased */
+	    /* Check if vid_cnt in call option needs to be increased */
 	    for (i = 0; i < call->med_cnt; ++i) {
 		if (call->media[i].type == PJMEDIA_TYPE_VIDEO &&
@@ -1709,6 +1709,6 @@
 		}
 	    }
-	    if (call->opt.video_cnt <= vid_cnt)
-		call->opt.video_cnt++;
+	    if (call->opt.vid_cnt <= vid_cnt)
+		call->opt.vid_cnt++;
 	}
 
@@ -1790,5 +1790,5 @@
 	pjmedia_sdp_media_deactivate(pool, sdp->media[med_idx]);
 
-	call->opt.video_cnt--;
+	call->opt.vid_cnt--;
     }
 